'======================================
' RoboPenguin - PenguinRemote_modem.bas
'======================================
PTP SETON
PTP ALLON
DIR G6A,1,1,1,0,0,0
DIR G6B,1,1,0,0,0,0
DIR G6C,0,0,0,0,0,0
DIR G6D,0,0,0,0,0,0
' Settaggio degli ZERO point
ZERO G6A,116,105,101,100,100,100
ZERO G6B,100,100,100,100,100,100
ZERO G6C,100,100,100,100,100,100
ZERO G6D,98,98,96,100,100,100
GETMOTORSET G6A,1,1,1,0,0,0
GETMOTORSET G6B,1,1,0,0,0,0
GETMOTORSET G6C,1,1,0,0,0,0
GETMOTORSET G6D,1,1,1,0,0,0
MOTOR G24
SPEED 10
TEMPO 230
MUSIC "CDE"
' Definizione variabili
DIM rr AS BYTE 			'Variabile lettura radiomodem
DIM temperatura AS BYTE 'Variabile sensore temperatura
DIM tensione AS BYTE	'Variabile lettura tensione 
' Variabile per memorizzare lo stato
' del LED (0 acceso, 1 spento)
DIM LED_status AS BYTE
DIM B AS BYTE
LED_status = 0
GOSUB standard_position
' Ciclo principale
main:
   Retry:
      ERX 9600, RR, Retry ''Lettura radiomodem
     
    IF RR = 49 THEN 	'Numero 1
        GOSUB music_control
    ELSEIF RR = 50 THEN 'Numero 2
        GOSUB LED_control
    ELSEIF RR = 51 THEN	'Numero 3
        GOSUB left_kick
    ELSEIF RR = 52 THEN	'Numero 4
        GOSUB right_kick
    ELSEIF RR = 53 THEN	'Numero 5
        GOSUB left_punch
    ELSEIF RR = 54 THEN	'Numero 6
        GOSUB right_punch
    ELSEIF RR = 55 THEN	'Numero 7
        GOSUB move_forward
    ELSEIF RR = 56 THEN	'Numero 8
        GOSUB move_backward
    ELSEIF RR = 57 THEN	'Numero 9
        GOSUB rotate_clockwise
    ELSEIF RR = 65 THEN	'Lettera A
        GOSUB rotate_counterclockwise
    ELSEIF RR = 84 THEN	'Lettera T
        GOSUB temperatura
    ELSEIF RR = 86 THEN	'Lettera V
        GOSUB tensione    
    ENDIF
    GOTO main
' Camminata in avanti
move_forward:
    MOVE G6A,100,100,110,,,
    MOVE G6B,100,10,,,,
    MOVE G6C,100,10,,,,
    MOVE G6D,100,100,110,,,
    WAIT
    MOVE G6D,70,100,110,,,
    MOVE G6A,115,100,110,,,
    MOVE G6A,96,105,98,,,
    MOVE G6D,100,100,128,,,
    MOVE G6A,115,85,90,,,
    MOVE G6D,90,110,125,,,
    WAIT
    FOR B = 1 TO 5
        MOVE G6A,80,85,90,,,
        MOVE G6D,115,110,125,,,
        MOVE G6A,100,85,100,,,
        MOVE G6D,115,85,90,,,
        MOVE G6A,90,110,125,,,
        WAIT
        MOVE G6D,80,85,90,,,
        MOVE G6A,115,110,125,,,
        MOVE G6D,100,85,100,,,
        MOVE G6A,115,85,90,,,
        MOVE G6D,90,110,125,,,
        WAIT
    NEXT B
    RR = 0
    GOSUB standard_position
    RETURN
' Camminata allindietro
move_backward:
    MOVE G6B,100,25,,,,
    MOVE G6C,100,25,,,,
    MOVE G6A,85,85,100,,,
    MOVE G6D,100,110,100,,,
    MOVE G6D,100,110,115,,,
    MOVE G6A,85,85,90,,,
    FOR B = 1 TO 5
        MOVE G6A,100,100,90,,,
        MOVE G6D,100,100,115,,,
        MOVE G6A,100,110,90,,,
        MOVE G6D,85,85,115,,,
        MOVE G6A,100,110,110,,,
        MOVE G6D,85,85,95,,,
        MOVE G6A,100,100,110,,,
        MOVE G6D,100,100,95,,,
        MOVE G6A,85,85,110,,,
        MOVE G6D,100,110,95,,,
        MOVE G6A,85,85,90,,,
        MOVE G6D,100,110,115,,,
    NEXT B
    RR = 0
    GOSUB standard_position
    RETURN
' Rotazione IN senso
' orario di 90 gradi
rotate_clockwise:
    FOR B = 1 TO 4
        MOVE G6D,130,80,,,
        MOVE G6C,100,10,,,,
        MOVE G6D,130,80,80,,,
        MOVE G6A,75,120,120,,,
        MOVE G6D,100,100,80,,,
        MOVE G6A,100,100,120,,,
    NEXT B
    RR = 0
    GOSUB standard_position
    RETURN
' Rotazione IN senso
' antiorario di 90 gradi
rotate_counterclockwise:
    FOR B = 1 TO 4
        MOVE G6A,130,80,100,,,
        MOVE G6B,100,10,,,,
        MOVE G6A,130,80,80,,,
        MOVE G6D,75,120,120,,,
        MOVE G6A,100,100,80,,,
        MOVE G6D,100,100,120,,,
    NEXT B
    RR = 0
    GOSUB standard_position
    RETURN
' Posizione standard
standard_position:
    MOVE G6A,100,100,100,,,
    MOVE G6D,100,100,100,,,
    MOVE G6B,100,10,,,,
    MOVE G6C,100,10,,,,
    RETURN
' Accensione e spegnimento LED
LED_control:
    IF LED_Status = 0 THEN
        LED_status = 1
    ELSE
        LED_Status = 0
    ENDIF
    OUT 52,LED_Status
    RR = 0
    RETURN
' Zampa destra up
right_kick:
    MOVE G6A,130,80,100,,,
    MOVE G6A,134,70,100,,,
    MOVE G6A,134,90,100,,,
    MOVE G6A,134,95,100,,,
    MOVE G6A,134,100,100,,,
    MOVE G6B,100,60,,,,
    MOVE G6C,190,10,,,,
    MOVE G6D,100,160,100,,,
    MOVE G6D,130,160,100,,,
    DELAY 500
    SPEED 15
    MOVE G6D,40,160,100,,,
    MOVE G6D,40,190,100,,,
    MOVE G6D,40,120,100,,,
    MOVE G6D,40,190,100,,,
    DELAY 500
    SPEED 10
    MOVE G6A,120,100,100,,,
    MOVE G6D,100,100,100,,,
    MOVE G6A,100,100,100,,,
    GOSUB standard_position
    RR = 0
    RETURN
' Zampa sinistra up
left_kick:
    MOVE G6D,130,80,100,,,
    MOVE G6D,134,70,100,,,
    MOVE G6D,134,90,100,,,
    MOVE G6D,134,95,100,,,
    MOVE G6D,134,100,100,,,
    MOVE G6C,100,60,,,,
    MOVE G6B,190,10,,,,
    MOVE G6A,100,160,100,,,
    MOVE G6A,130,160,100,,,
    DELAY 500
    SPEED 15
    MOVE G6A,40,160,100,,,
    MOVE G6A,40,190,100,,,
    MOVE G6A,40,120,100,,,
    MOVE G6A,40,190,100,,,
    DELAY 500
    SPEED 10
    MOVE G6D,120,100,100,,,
    MOVE G6A,100,100,100,,,
    MOVE G6D,100,100,100,,,
    GOSUB standard_position
    RR = 0
    RETURN
' Attiva breve sequenza musicale
music_control:
    MUSIC "ABCD"
    RR = 0
    RETURN
' Pugno destro
right_punch:
    HIGHSPEED SETON
    MOVE G6C,180,30,,,,
    MOVE G6A,100,100,85,,,
    MOVE G6D,100,100,115,,,
    HIGHSPEED SETOFF
    DELAY 1000
    RR = 0
    GOSUB standard_position
    RETURN
' Pugno sinistro
left_punch:
    HIGHSPEED SETON
    MOVE G6B,180,30,,,,
    MOVE G6D,100,100,85,,,
    MOVE G6A,100,100,115,,,
    HIGHSPEED SETOFF
    DELAY 1000
    RR = 0
    GOSUB standard_position
    RETURN
    
' Trasmissione dato temperatura
temperatura:
temperatura = AD(2)
ETX 9600, temperatura
RETURN

' Trasmissione dato tensione batteria
tensione:
tensione = AD(6)
ETX 9600, tensione
RETURN
